SystemOrganization addCategory: #'NetworkAddress-Description'!
SystemOrganization addCategory: #'NetworkAddress-Component'!
SystemOrganization addCategory: #'NetworkAddress-Test'!

MAStringDescriptionTest subclass: #NAEmailDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Test'!

!NAEmailDescriptionTest methodsFor: 'private' stamp: 'pmm 8/28/2005 15:48'!
includedInstance
	^'myname@sub.domain.com'! !

!NAEmailDescriptionTest methodsFor: 'private' stamp: 'pmm 12/9/2005 15:35'!
testedClass
	^NAEmailDescription ! !

!NAEmailDescriptionTest methodsFor: 'testing-validation' stamp: 'pmm 11/14/2005 12:14'!
testNegative
	self should: [ self description validate: 'me@spam' ] raise: MAValidationError.
	self should: [ self description validate: 'super.com' ] raise: MAValidationError.
	self should: [ self description validate: '@super.com' ] raise: MAValidationError.
	self should: [ self description validate: 'me.self@' ] raise: MAValidationError.
	self should: [ self description validate: 'me.self' ] raise: MAValidationError.! !

!NAEmailDescriptionTest methodsFor: 'testing-validation' stamp: 'pmm 8/28/2005 15:49'!
testPositive
	self assert: (self description isSatisfiedBy: 'me@spam.com').
	self assert: (self description isSatisfiedBy: 'me@spam.super.com').
	self assert: (self description isSatisfiedBy: 'me.self@spam.com').
	self assert: (self description isSatisfiedBy: 'me.self@spam.com').
	self assert: (self description isSatisfiedBy: 'me.self1@spam.com').
	self assert: (self description isSatisfiedBy: 'me.self.very@spam.com').
	self assert: (self description isSatisfiedBy: 'me.self.very@spam.super.com').
	self assert: (self description isSatisfiedBy: 'me_self@spam.com').
	self assert: (self description isSatisfiedBy: 'me-self@spam.super.com').! !

MATextInputComponent subclass: #NAEmailComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Component'!

!NAEmailComponent methodsFor: 'rendering' stamp: 'pmm 11/6/2005 21:23'!
renderViewerOn: html
	html anchor mailto: self string! !

MATextInputComponent subclass: #NAIMComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Component'!

!NAIMComponent methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:47'!
altText
	self subclassResponsability ! !

!NAIMComponent methodsFor: 'testing' stamp: 'pmm 11/12/2005 16:44'!
displayStatus
	^self string isEmptyOrNil not! !

!NAIMComponent methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:48'!
queryUrl
	self subclassResponsability ! !

!NAIMComponent methodsFor: 'rendering' stamp: 'pmm 11/12/2005 16:48'!
renderStatusIconOn: html
	html image
		url: self queryUrl ;
		altText: self altText! !

!NAIMComponent methodsFor: 'rendering' stamp: 'pmm 11/12/2005 16:47'!
renderViewerOn: html	
	self displayStatus
		ifFalse: [ super renderViewerOn: html ]
		ifTrue: [
			html table: [
				html tableRow: [
					html tableData
						style: 'vertical-align:middle';
						with: [ super renderViewerOn: html ].
					html tableData
						style: 'vertical-align:middle';
						with: [ self renderStatusIconOn: html ] ] ] ]! !

NAIMComponent subclass: #NASendableIMComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Component'!

NASendableIMComponent subclass: #NAAIMComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Component'!

!NAAIMComponent commentStamp: '<historical>' prior: 0!
http://www.aim.com/remote/index.adp?aolp=
<img src=http://big.oscar.aol.com/screenname?on_url=http://www.aim.com/remote/gr/MNB_online.gif&off_url=http://www.aim.com/remote/gr/MNB_offline.gif border=0 width=11 height=13>!

!NAAIMComponent methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:50'!
altText
	^'AIM status of ' , self string! !

!NAAIMComponent methodsFor: 'accessing' stamp: 'pmm 11/12/2005 17:02'!
queryUrl
	^String streamContents: [ :stream |
		stream
			nextPutAll: 'http://big.oscar.aol.com/';
			nextPutAll: self string;
			nextPutAll: '?on_url=';
			nextPutAll: self description onlineUrl;
			nextPutAll: '&off_url=';
			nextPutAll: self description offlineUrl]! !

!NAAIMComponent methodsFor: 'accessing' stamp: 'pmm 11/13/2005 01:15'!
sendUrl
	^'aim:goim?screenname=' , self string! !

NASendableIMComponent subclass: #NAICQComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Component'!

!NAICQComponent commentStamp: '<historical>' prior: 0!
http://www.icq.com/features/web/indicator.html
http://www.icq.com/panels/wwp/
http://www.icq.com/webtools/webmasters.html
http://www.icq.com/whitepages/search_result.php?search_type=&fname=&lname=wasserfallen&nickname=&gender=&age_group=&home_country_code=&email=!

!NAICQComponent methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:46'!
altText
	^'ICQ status of ' , self string! !

!NAICQComponent methodsFor: 'private' stamp: 'pmm 9/28/2005 20:57'!
imageIndex
	^self description imageIndex! !

!NAICQComponent methodsFor: 'private' stamp: 'pmm 11/12/2005 16:45'!
queryUrl
	^String streamContents: [ :stream |
		stream
			nextPutAll: 'http://status.icq.com/online.gif?icq=';
			nextPutAll: self string;
			nextPutAll: '&img=';
			nextPutAll: self imageIndex asString ]! !

!NAICQComponent methodsFor: 'accessing' stamp: 'pmm 11/13/2005 01:12'!
sendUrl
	^'http://www.icq.com/whitepages/wwp.php?uin=' , self string! !

!NASendableIMComponent methodsFor: 'rendering' stamp: 'pmm 11/13/2005 23:10'!
renderStatusIconOn: html
	self displayStatus
		ifFalse: [ super renderStatusIconOn: html ]
		ifTrue: [
			html anchor
				url: self sendUrl;
				with: [ super renderStatusIconOn: html ] ]! !

!NASendableIMComponent methodsFor: 'accessing' stamp: 'pmm 12/9/2005 15:43'!
sendUrl
	self subclassResponsability ! !

NASendableIMComponent subclass: #NAYahooComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Component'!

!NAYahooComponent commentStamp: '<historical>' prior: 0!
http://messenger.yahoo.com/messenger/help/online.html
http://confluence.atlassian.com/display/CONFEXT/Yahoo+Status+macro
http://curl.haxx.se/mail/curlphp-2005-01/0029.html!

!NAYahooComponent methodsFor: 'accessing' stamp: 'pmm 11/12/2005 17:07'!
altText
	^'Yahoo status of ' , self string! !

!NAYahooComponent methodsFor: 'accessing' stamp: 'pmm 11/13/2005 00:56'!
queryUrl
	^String streamContents: [ :stream |
		stream
			nextPutAll: 'http://opi.yahoo.com/online?u=';
			nextPutAll: self string;
			nextPutAll: '&m=g&t=';
			nextPutAll: self description themeIndex asString ]! !

!NAYahooComponent methodsFor: 'accessing' stamp: 'pmm 11/13/2005 01:08'!
sendUrl
	^'http://edit.yahoo.com/config/send_webmesg?.target=' , self string! !

MATextInputComponent subclass: #NAJabberComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Component'!

!NAJabberComponent commentStamp: '<historical>' prior: 0!
http://edgar.netflint.net/howto.php!

MANumberDescription subclass: #NAICQDescription
	instanceVariableNames: 'imageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Description'!

!NAICQDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 12/9/2005 15:38'!
defaultComponentClasses
	^ Array with: NAICQComponent.! !

!NAICQDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 9/28/2005 20:54'!
defaultImageIndex
	^10! !

!NAICQDescription class methodsFor: 'accessing-description' stamp: 'pmm 11/7/2005 00:28'!
descriptionImageIndex
	"^(MANumberDescription selector: #imageIndex label: 'Design #' priority: 100)
		lowerBounds: self imageIndexLowerBound;
		upperBounds: self imageIndexUpperBound;
		beRequired;
		yourself"
	^(MASingleOptionDescription selector: #imageIndex label: 'Design #' priority: 100)
		options: self possibleImageIndices;
		default: self defaultImageIndex;
		reference: MANumberDescription new;
		beRequired;
		yourself.
		! !

!NAICQDescription class methodsFor: 'private' stamp: 'pmm 9/28/2005 20:52'!
imageIndexLowerBound
	^0! !

!NAICQDescription class methodsFor: 'private' stamp: 'pmm 9/28/2005 20:53'!
imageIndexUpperBound
	^25! !

!NAICQDescription class methodsFor: 'accessing' stamp: 'pmm 11/12/2005 17:11'!
label
	^ 'ICQ'! !

!NAICQDescription class methodsFor: 'private' stamp: 'pmm 9/28/2005 20:53'!
possibleImageIndices
	^(self imageIndexLowerBound to: self imageIndexUpperBound) asArray! !

!NAICQDescription methodsFor: 'accessing' stamp: 'pmm 9/28/2005 20:47'!
imageIndex
	^imageIndex! !

!NAICQDescription methodsFor: 'accessing' stamp: 'pmm 9/28/2005 20:47'!
imageIndex: anInteger 
	imageIndex := anInteger! !

!NAICQDescription methodsFor: 'initialize-release' stamp: 'pmm 9/30/2005 10:06'!
initialize
	super initialize.
	self flag: #todo. "restrict to positive integer"
	self imageIndex: self class defaultImageIndex! !

MANumberDescription subclass: #NAYahooDescription
	instanceVariableNames: 'themeIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Description'!

!NAYahooDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 12/9/2005 15:39'!
defaultComponentClasses
	^ Array with: NAYahooComponent.! !

!NAYahooDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 11/13/2005 00:55'!
defaultThemeIndex
	^2! !

!NAYahooDescription class methodsFor: 'accessing-description' stamp: 'pmm 11/13/2005 00:55'!
descriptionThemeIndex
	^(MASingleOptionDescription selector: #themeIndex label: 'Theme #' priority: 100)
		options: self possibleThemeIndices;
		default: self defaultThemeIndex;
		reference: MANumberDescription new;
		beRequired;
		yourself.! !

!NAYahooDescription class methodsFor: 'accessing' stamp: 'pmm 11/12/2005 17:12'!
label
	^ 'Yahoo!!'! !

!NAYahooDescription class methodsFor: 'private' stamp: 'pmm 11/13/2005 00:53'!
possibleThemeIndices
	^(1 to: 3) asArray! !

!NAYahooDescription methodsFor: 'initialize-release' stamp: 'pmm 11/13/2005 00:55'!
initialize
	super initialize.
	self themeIndex: self class defaultThemeIndex! !

!NAYahooDescription methodsFor: 'accessing' stamp: 'pmm 11/13/2005 00:52'!
themeIndex
	^themeIndex! !

!NAYahooDescription methodsFor: 'accessing' stamp: 'pmm 11/13/2005 00:52'!
themeIndex: anInteger 
	themeIndex := anInteger! !

MAStringDescription subclass: #NAAIMDescription
	instanceVariableNames: 'onlineUrl offlineUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Description'!

!NAAIMDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 12/9/2005 15:37'!
defaultComponentClasses
	^ Array with: NAAIMComponent.! !

!NAAIMDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 11/12/2005 16:55'!
defaultOfflineUrl
	^'http://www.aim.com/remote/gr/MNB_offline.gif'! !

!NAAIMDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 11/12/2005 16:54'!
defaultOnlineUrl
	^'http://www.aim.com/remote/gr/MNB_online.gif'! !

!NAAIMDescription class methodsFor: 'accessing-description' stamp: 'pmm 11/12/2005 16:57'!
descriptionOfflineUrl
	^(MAStringDescription selector: #offlineUrl label: 'Ofline URL' priority: 200)
		default: self defaultOfflineUrl;
		beRequired;
		yourself! !

!NAAIMDescription class methodsFor: 'accessing-description' stamp: 'pmm 11/12/2005 16:57'!
descriptionOnlineUrl
	^(MAStringDescription selector: #onlineUrl label: 'Online URL' priority: 100)
		default: self defaultOnlineUrl;
		beRequired;
		yourself! !

!NAAIMDescription class methodsFor: 'accessing' stamp: 'pmm 11/12/2005 17:11'!
label
	^ 'AIM'! !

!NAAIMDescription methodsFor: 'initialize-release' stamp: 'pmm 11/12/2005 16:58'!
initialize
	super initialize.
	self onlineUrl: self class defaultOnlineUrl.
	self offlineUrl: self class defaultOfflineUrl! !

!NAAIMDescription methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:51'!
offlineUrl
	^offlineUrl! !

!NAAIMDescription methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:57'!
offlineUrl: aString 
	offlineUrl := aString! !

!NAAIMDescription methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:51'!
onlineUrl
	^onlineUrl! !

!NAAIMDescription methodsFor: 'accessing' stamp: 'pmm 11/12/2005 16:57'!
onlineUrl: aString 
	onlineUrl := aString! !

MAStringDescription subclass: #NAEmailDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetworkAddress-Description'!

NAEmailDescription class
	instanceVariableNames: 'qtextchars'!

!NAEmailDescription commentStamp: 'pmm 8/6/2005 21:29' prior: 0!
see RFC 2822!

!NAEmailDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 12/9/2005 15:37'!
defaultComponentClass
	^NAEmailComponent! !

!NAEmailDescription class methodsFor: 'class initialization' stamp: 'pmm 8/6/2005 21:15'!
initialize
	"self initialize"
	qtextchars :=
		(((33 to: 126)
			collect: [ :each | each asCharacter ])
			asOrderedCollection
			remove: 34 asCharacter;
			remove: 92 asCharacter;
			remove: $@;
			remove: $.;
			yourself)! !

!NAEmailDescription class methodsFor: 'converting' stamp: 'pmm 11/6/2005 12:24'!
label
	^'Email Address'! !

!NAEmailDescription class methodsFor: 'accessing' stamp: 'pmm 8/6/2005 21:20'!
qtextchars
	^ qtextchars! !

!NAEmailDescription methodsFor: 'converting' stamp: 'pmm 11/7/2005 00:55'!
fromString: aString
	^(aString isEmptyOrNil or: [ self isEmailString: aString])
		ifTrue: [ super fromString: aString ]
		ifFalse: [ self error: 'not valid email address' ]! !

!NAEmailDescription methodsFor: 'testing' stamp: 'pmm 8/28/2005 15:42'!
isDomainPart: aString
	^(aString subStrings: '.') in: [ :substrings |
		substrings size >= 2
		and: [
			substrings allSatisfy: [ :each |
				self isQuotedString: each ]]].! !

!NAEmailDescription methodsFor: 'testing' stamp: 'pmm 8/28/2005 15:42'!
isEmailString: aString
	aString ifNil: [ ^false ].
	^ (aString subStrings: '@') in: [ :parts |
		parts size = 2
			and: [ self isLocalPart: parts first ]
			and: [ self isDomainPart: parts second ] ].! !

!NAEmailDescription methodsFor: 'testing' stamp: 'pmm 8/28/2005 15:42'!
isLocalPart: aString
	^(aString subStrings: '.')
		allSatisfy: [ :each |
			self isQuotedString: each ].! !

!NAEmailDescription methodsFor: 'testing' stamp: 'pmm 8/6/2005 21:21'!
isQuotedString: aString
	^ aString isEmpty not
		and: [ aString allSatisfy: [ :each |
			self qtextchars includes: each ]].! !

!NAEmailDescription methodsFor: 'accessing' stamp: 'pmm 8/6/2005 21:21'!
qtextchars
	^self class qtextchars! !

!NAEmailDescription methodsFor: 'testing' stamp: 'pmm 11/14/2005 12:09'!
validateSpecific: aString
	super validateSpecific: aString.
	(self isEmailString: aString)
		ifFalse: [ SVInvalidEmailError on: self ]! !
NAEmailDescription initialize!
